# **Contributing to gRelay**

First of all, thanks for the interest in contributing, we can do great work together :earth_americas: :leaves:

The following is a set of guidelines for contributing to gRelay project. It is important to be clear, these guidelines are just guidelines, not rules. Use it for your best judgment, and feel free to propose changes to this document.

#### **Table Of Contents**
[:earth_africa: How can I contribute?](#earth_africa-how-can-i-contribute)

  * [:bug: Reporting bugs](#bug-reporting-bugs)

  * [:bulb: Suggesting an enhancement](#bulb-suggesting-an-enhancement)

  * [:octocat: Code contributtion](#octocat-code-contributtion)

[:art: Styleguides](#art-styleguides)

## **:earth_africa: How can I contribute?**

### **:bug: Reporting bugs**

  If you found out a bug, follow these steps:

  * Ensure the bug was not already reported by searching on GitHub under [Issues](https://github.com/grelay/grelay/issues).

  * If you didn't find out any issue opened, open an [issue](https://github.com/grelay/grelay/issues) that follows the [bug_report.md](https://github.com/grelay/grelay/blob/main/.github/ISSUE_TEMPLATE/bug_report.md) template.

### **:bulb: Suggesting an enhancement**

  If you want to suggest a new feature to gRelay, follow these steps:

  * Check if the enhancement was not already implemented;

  * If the enhancement was not already implemented, open an [issue](https://github.com/grelay/grelay/issues) that follows the [feature_request.md](https://github.com/grelay/grelay/blob/main/.github/ISSUE_TEMPLATE/feature_request.md) template.

### :octocat: Code contributtion

  * If you want to contribute to the project and this is the first time here, we recommend searching an [issue](https://github.com/grelay/grelay/issues) with the `good first issue` label

  * If you are looking for contribute to the project and this is not your first time here, we recommend searching for some [issue](https://github.com/grelay/grelay/issues) which has a `bug` label or `enhancement` label

  * After find out your issue, you can fork the gRelay project and start to develop the solution. Don't forget to [configure your forked project](https://docs.github.com/en/github/collaborating-with-issues-and-pull-requests/configuring-a-remote-for-a-fork)

  * Before open a Pull Request, run the tests and check if the code is following the [styleguide](#art-styleguides)

  * Finally, open a Pull Request following the [pull_request_template.md](https://github.com/grelay/grelay/blob/main/.github/pull_request_template.md) template.

## **:art: Styleguides**

  * We indent using two spaces (soft tabs)

  * Clear variable name (`var p periodType = thirdPeriod`)

  * Clear comments above the public methods

  * This is an open source project. Consider the people who will read your code, and make it look nice for them.

Thanks! :hearts:

gRelay team
